Subject: Re: bug#57728: 29.0.50; Emacs writes wrong glyph at the bottom-right corner of text terminals

From: Akib Azmain Turja <[email-masked]>
Date: Mon, 12 Sep 2022 13:56:01 +0600

Eli Zaretskii <[email-masked]> writes:

>> From: Lars Ingebrigtsen <[email-masked]>
>> Cc: [email-masked],  [email-masked]
>> Date: Sun, 11 Sep 2022 20:18:03 +0200
>> 
>> Eli Zaretskii <[email-masked]> writes:
>> 
>> > Doesn't happen here, neither on MS-Windows nor on GNU/Linux to which I
>> > SSH-login via PuTTY (which AFAIK emulates xterm).  I guess this really
>> > is specific to some terminals.
>> 
>> My example was with gnome-terminal on the current Ubuntu, for what it's
>> worth.
>
> Someone with access to that terminal will have to debug this.

I can reproduce on XTerm and Linux console, I hope you have access to
those.

>
> My guess is that something we do when we rewrite the lines while
> scrolling the display erases those glyphs by side effect, but Emacs
> doesn't know that.  Since all the lines have the continuation glyph,
> it makes sense for Emacs to rewrite only the part of each line up to
> and excluding the continuation glyphs, relying on them to remain on
> the glass.

Yeah, tty_write_glyphs and tty_write_glyphs_with_face in term.c does the
magic, it doesn't dare to write to that (bottom-right corner) position.

-- 
Akib Azmain Turja

Find me on Mastodon at @[email-masked].

This message is signed by me with my GnuPG key.  Its fingerprint is:

    7001 8CE5 819F 17A3 BBA6  66AF E74F 0EFA 922A E7F5